import { SvelteComponent, init, safe_not_equal, assign, element, set_attributes, toggle_class, insert, listen, get_spread_update, noop, detach, compute_rest_props, exclude_internal_props, binding_callbacks } from 'svelte/internal';
import { onMount } from 'svelte';

/* src/LazyImage.svelte generated by Svelte v3.37.0 */

function create_fragment(ctx) {
	let img;
	let img_src_value;
	let mounted;
	let dispose;

	let img_levels = [
		{ src: img_src_value = /*path*/ ctx[2] },
		{ alt: /*alt*/ ctx[0] },
		/*$$restProps*/ ctx[5],
		{ class: "svelte-lazy-image" }
	];

	let img_data = {};

	for (let i = 0; i < img_levels.length; i += 1) {
		img_data = assign(img_data, img_levels[i]);
	}

	return {
		c() {
			img = element("img");
			set_attributes(img, img_data);
			toggle_class(img, "svelte-lazy-image--loaded", /*loaded*/ ctx[3]);
		},
		m(target, anchor) {
			insert(target, img, anchor);
			/*img_binding*/ ctx[9](img);

			if (!mounted) {
				dispose = listen(img, "load", /*handleLoad*/ ctx[4]);
				mounted = true;
			}
		},
		p(ctx, [dirty]) {
			set_attributes(img, img_data = get_spread_update(img_levels, [
				dirty & /*path*/ 4 && img.src !== (img_src_value = /*path*/ ctx[2]) && { src: img_src_value },
				dirty & /*alt*/ 1 && { alt: /*alt*/ ctx[0] },
				dirty & /*$$restProps*/ 32 && /*$$restProps*/ ctx[5],
				{ class: "svelte-lazy-image" }
			]));

			toggle_class(img, "svelte-lazy-image--loaded", /*loaded*/ ctx[3]);
		},
		i: noop,
		o: noop,
		d(detaching) {
			if (detaching) detach(img);
			/*img_binding*/ ctx[9](null);
			mounted = false;
			dispose();
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	const omit_props_names = ["placeholder","src","alt"];
	let $$restProps = compute_rest_props($$props, omit_props_names);

	let observerCallback = function (entries, observer) {
		entries.forEach(entry => {
			if (entry.isIntersecting) {
				$$invalidate(8, intersected = true);
				observer.unobserve(imgElement);
			}
		});
	};

	let { placeholder } = $$props;
	let { src } = $$props;
	let { alt } = $$props;
	let imgElement;
	let path;
	let observer;
	let intersected = false;
	let loaded = false;

	onMount(() => {
		observer = new IntersectionObserver(observerCallback);
		observer.observe(imgElement);

		return () => {
			observer.unobserve(imgElement);
		};
	});

	function handleLoad() {
		if (!loaded && path === src) {
			$$invalidate(3, loaded = true);
		}
	}

	function img_binding($$value) {
		binding_callbacks[$$value ? "unshift" : "push"](() => {
			imgElement = $$value;
			$$invalidate(1, imgElement);
		});
	}

	$$self.$$set = $$new_props => {
		$$props = assign(assign({}, $$props), exclude_internal_props($$new_props));
		$$invalidate(5, $$restProps = compute_rest_props($$props, omit_props_names));
		if ("placeholder" in $$new_props) $$invalidate(6, placeholder = $$new_props.placeholder);
		if ("src" in $$new_props) $$invalidate(7, src = $$new_props.src);
		if ("alt" in $$new_props) $$invalidate(0, alt = $$new_props.alt);
	};

	$$self.$$.update = () => {
		if ($$self.$$.dirty & /*intersected, src, placeholder*/ 448) {
			$$invalidate(2, path = intersected ? src : placeholder);
		}
	};

	return [
		alt,
		imgElement,
		path,
		loaded,
		handleLoad,
		$$restProps,
		placeholder,
		src,
		intersected,
		img_binding
	];
}

class LazyImage extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance, create_fragment, safe_not_equal, { placeholder: 6, src: 7, alt: 0 });
	}
}

export default LazyImage;
export { LazyImage };
